WITH O(OBJ,LINK) AS
(
SELECT 'A', 'B' FROM DUAL UNION ALL
SELECT 'A', 'C' FROM DUAL UNION ALL
SELECT      'C', 'D' FROM DUAL UNION ALL
SELECT           'D', 'C' FROM DUAL UNION ALL
SELECT           'D', 'E' FROM DUAL UNION ALL
SELECT                'E', 'E' FROM DUAL
),
T(ROOT,LEV,OBJ,LINK,PATH) AS (
SELECT OBJ,1,OBJ,LINK,CAST(OBJ||'->'||LINK 
AS VARCHAR2(4000))
FROM O 
WHERE OBJ='A'  -- START WITH
UNION ALL
SELECT 
  T.ROOT,T.LEV+1,O.OBJ,O.LINK,
  T.PATH||', '||O.OBJ||
    '->'
    ||O.LINK
FROM T, O 
WHERE T.LINK=O.OBJ
)
SEARCH DEPTH FIRST BY OBJ SET ORD
CYCLE OBJ SET CYCLE TO 1 DEFAULT 0
SELECT ROOT,LEV,OBJ,LINK,PATH,CYCLE,
    CASE
    WHEN (LEV - LEAD(LEV) OVER (ORDER BY ORD)) < 0
    THEN 0
    ELSE 1
    END IS_LEAF
 FROM T

;
