select  count(*), max(scn)
from
(
	select sp.BO#, sp.PMOPTYPE, sp.scn, sp.flags
	from sumpartlog$ sp, sumdep$ sd
	where sd.sumobj# = :1 and sd.p_obj# = sp.bo#
	group by sp.BO#, sp.PMOPTYPE, sp.scn, sp.flags
	minus
	select sp.BO#, sp.PMOPTYPE, sp.scn, sp.flags
	from sumpartlog$ sp
	where sp.bo# not in
	(
		select sk.DETAILOBJ# from sumkey$ sk where sk.sumobj# = :1 and sk.DETAILCOLFUNCTION in (2,3)
	)
	and bitand(sp.flags, 2) != 2 and sp.PMOPTYPE in (2,3,5,7)
	group by sp.BO#, sp.PMOPTYPE, sp.scn, sp.flags
)
where scn > : 2
;