WITH O AS
(
	SELECT 'A' OBJ, 'B' LINK FROM DUAL UNION ALL
	SELECT 'A', 'C' FROM DUAL UNION ALL
	SELECT      'C', 'D' FROM DUAL UNION ALL
	SELECT           'D', 'C' FROM DUAL UNION ALL
	SELECT           'D', 'E' FROM DUAL UNION ALL
	SELECT                'E', 'E' FROM DUAL
)
SELECT 
  CONNECT_BY_ROOT OBJ ROOT,
  LEVEL,
  OBJ,LINK,
  SYS_CONNECT_BY_PATH(OBJ||'->'||LINK,','),
  CONNECT_BY_ISCYCLE,
  CONNECT_BY_ISLEAF
FROM O
CONNECT BY NOCYCLE OBJ=PRIOR LINK
START WITH OBJ='A'
;
