SELECT :B3 AS L_SNAP_ID , :B2 AS P_DBID , :B1 AS P_INSTANCE_NUMBER , NVL(PID, -9) PID , NVL(SERIAL#, -9) SERIAL# , DECODE(PID, NULL, NULL, MAX(SPID)) SPID ,
 DECODE(PID, NULL, NULL, MAX(PROGRAM)) PROGRAM , DECODE(PID, NULL, NULL, MAX(BACKGROUND)) BACKGROUND , SUM(PGA_USED_MEM) PGA_USED_MEM ,
 SUM(PGA_ALLOC_MEM) PGA_ALLOC_MEM , SUM(PGA_FREEABLE_MEM) PGA_FREEABLE_MEM , MAX(PGA_ALLOC_MEM) MAX_PGA_ALLOC_MEM , MAX(PGA_MAX_MEM) MAX_PGA_MAX_MEM ,
 DECODE(PID, NULL, AVG(PGA_ALLOC_MEM), NULL) AVG_PGA_ALLOC_MEM , DECODE(PID, NULL, STDDEV(PGA_ALLOC_MEM), NULL) STDDEV_PGA_ALLOC_MEM ,
 DECODE(PID, NULL, COUNT(PID), NULL) NUM_PROCESSES
 FROM V$PROCESS
 WHERE PROGRAM != 'PSEUDO'
 GROUP BY GROUPING SETS ( (PID, SERIAL#), () )
;
