WITH
  REPORTS_TO_101 (EID, EMP_LAST, MGR_ID, REPORTLEVEL) AS
  (
    SELECT EMPLOYEE_ID, LAST_NAME, MANAGER_ID, 0 REPORTLEVEL
    FROM EMPLOYEES
    WHERE EMPLOYEE_ID = 101
  UNION ALL
    SELECT E.EMPLOYEE_ID, E.LAST_NAME, E.MANAGER_ID, REPORTLEVEL+1
    FROM REPORTS_TO_101 R, EMPLOYEES E
    WHERE R.EID = E.MANAGER_ID
  )
SELECT EID, EMP_LAST, MGR_ID, REPORTLEVEL
FROM REPORTS_TO_101
WHERE REPORTLEVEL <= 1
ORDER BY REPORTLEVEL, EID
;
