DECLARE
	TYPE NumList IS TABLE OF NUMBER;
	rownos NumList;

	TYPE NameList IS TABLE OF VARCHAR2(30);
	tnames NameList;
BEGIN
	rownos := NumList(2,4,6,8,16);

	FORALL i IN 1..5
 	EXECUTE IMMEDIATE ' UPDATE tmp_target SET id = id * 1.1
 	WHERE id = :1
	RETURNING table_name INTO :2'
 	USING rownos(i) RETURNING BULK COLLECT INTO tnames;

 	FOR j IN 1..5
 	LOOP
		dbms_output.put_line(tnames(j));
 	END LOOP;
END;