DECLARE
	s PLS_INTEGER := 0;
	i PLS_INTEGER := 0;
	j PLS_INTEGER;
BEGIN
	<<outer_loop>>
	LOOP
	i := i + 1;
	j := 0;
	  <<inner_loop>>
	  LOOP
		j := j + 1;
	  	s := s + i * j; -- Sum several products
	  	EXIT inner_loop WHEN (j > 5);
	  	EXIT outer_loop WHEN ((i * j) > 15);
	  END LOOP inner_loop;
	END LOOP outer_loop;
	DBMS_OUTPUT.PUT_LINE('The sum of products equals: ' || TO_CHAR(s));

	LOOP -- After CONTINUE statement, control resumes here
	     DBMS_OUTPUT.PUT_LINE ('Inside loop: x = ' || TO_CHAR(x));
	     x := x + 1;
	     IF x < 3 THEN
	     	CONTINUE;
	     END IF;
	     DBMS_OUTPUT.PUT_LINE ('Inside loop, after CONTINUE: x = ' || TO_CHAR(x));
	     EXIT WHEN x = 5;
	END LOOP;

	FOR i IN 1..3 LOOP
	    DBMS_OUTPUT.PUT_LINE (i);
	END LOOP;

	FOR i IN REVERSE 1..3 LOOP
	    DBMS_OUTPUT.PUT_LINE (i);
	END LOOP;

	OPEN c1;
	-- Fetch entire row into v_employees record:
	FOR i IN 1..10 LOOP
	    FETCH c1 INTO v_employees;
	    EXIT WHEN c1%NOTFOUND;
	    -- Process data here
	END LOOP;
	CLOSE c1;

	DECLARE
		done BOOLEAN := FALSE;
	BEGIN
		WHILE done LOOP
		      DBMS_OUTPUT.PUT_LINE ('This line does not print.');
		      done := TRUE; -- This assignment is not made.
		END LOOP;
		
		WHILE NOT done LOOP
		      DBMS_OUTPUT.PUT_LINE ('Hello, world!');
		      done := TRUE;
		END LOOP;
	END;
	
END;
