SELECT
	STALENESS, OSIZE, OBJ#, TYPE#,
	CASE
	WHEN STALENESS > .5 THEN 128
	WHEN STALENESS > .1 THEN 256
	ELSE 0
	END + AFLAGS AFLAGS,
	STATUS,
	SID,
	SERIAL#,
	PART#,
	BO#
	,
	CASE
	WHEN IS_FULL_EVENTS_HISTORY = 1 THEN SRC.BOR_LAST_STATUS_TIME
	ELSE 
		CASE GREATEST (NVL (WP.BOR_LAST_STAT_TIME, DATE '1900-01-01'), NVL (SRC.BOR_LAST_STATUS_TIME, DATE '1900-01-01'))
		WHEN DATE '1900-01-01' THEN NULL
		WHEN WP.BOR_LAST_STAT_TIME THEN WP.BOR_LAST_STAT_TIME
		WHEN SRC.BOR_LAST_STATUS_TIME THEN SRC.BOR_LAST_STATUS_TIME
		ELSE NULL
		END
	END
	,
	CASE GREATEST (NVL (WP.BOR_LAST_STAT_TIME, DATE '1900-01-01'), NVL (SRC.BOR_LAST_STATUS_TIME, DATE '1900-01-01'))
	WHEN DATE '1900-01-01' THEN NULL
	WHEN WP.BOR_LAST_STAT_TIME THEN WP.BOR_LAST_STAT_TIME
	WHEN SRC.BOR_LAST_STATUS_TIME THEN SRC.BOR_LAST_STATUS_TIME
	ELSE NULL
	END	
FROM X
;
